using System;

namespace PolymorphismDemo
{
	class Person 
	{
		public virtual void PrintName() 
		{
			Console.WriteLine("I am an instance of {0}.", 
				this.GetType().Name);
		}
	}

	class Instructor : Person
	{
		public override void PrintName() 
		{
			Console.WriteLine("I am an instructor.");
		}
	}

	class Student : Person
	{
		public override void PrintName() 
		{
			base.PrintName();
			Console.WriteLine("I am a student.");
		}
	}


	class PolymorphismTest
	{
		static void PrintPersonName(Person aPerson) 
		{
			aPerson.PrintName();
		}

		static void Main(string[] args)
		{
			Person person = new Person();
			Console.Write("Person: ");
			PrintPersonName(person);
			// Person: I am an instance of Person.

			Person instructor = new Instructor();
			Console.Write("\nInstructor: ");
			PrintPersonName(instructor);
			// Instructor: I am an instructor.

			Person student = new Student();
			Console.Write("\nStudent: ");
			PrintPersonName(student);
			// Student: I am an instance of Student.
			// I am a student.
		}
	}
}
